Index: cpukit/score/src/threadloadenv.c
===================================================================
--- cpukit/score/src/threadloadenv.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadloadenv.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,69 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Load_environment
+ *
+ *  Load starting environment for another thread from its start area in the
+ *  thread.  Only called from t_restart and t_start.
+ *
+ *  Input parameters:
+ *    the_thread - thread control block pointer
+ *
+ *  Output parameters:  NONE
+ */
+
+void _Thread_Load_environment(
+  Thread_Control *the_thread
+)
+{
+  boolean is_fp = FALSE;
+
+  if ( the_thread->Start.fp_context ) {
+    the_thread->fp_context = the_thread->Start.fp_context;
+    _Context_Initialize_fp( &the_thread->fp_context );
+    is_fp = TRUE;
+  }
+
+  the_thread->do_post_task_switch_extension = FALSE;
+  the_thread->is_preemptible   = the_thread->Start.is_preemptible;
+  the_thread->budget_algorithm = the_thread->Start.budget_algorithm;
+  the_thread->budget_callout   = the_thread->Start.budget_callout;
+
+  _Context_Initialize(
+    &the_thread->Registers,
+    the_thread->Start.Initial_stack.area,
+    the_thread->Start.Initial_stack.size,
+    the_thread->Start.isr_level,
+    _Thread_Handler,
+    is_fp
+  );
+
+}
Index: cpukit/score/src/threadready.c
===================================================================
--- cpukit/score/src/threadready.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadready.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,75 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Ready
+ *
+ *  This kernel routine readies the requested thread, the thread chain
+ *  is adjusted.  A new heir thread may be selected.
+ *
+ *  Input parameters:
+ *    the_thread - pointer to thread control block
+ *
+ *  Output parameters:  NONE
+ *
+ *  NOTE:  This routine uses the "blocking" heir selection mechanism.
+ *         This insures the correct heir after a thread restart.
+ *
+ *  INTERRUPT LATENCY:
+ *    ready chain
+ *    select heir
+ */
+
+void _Thread_Ready(
+  Thread_Control *the_thread
+)
+{
+  ISR_Level              level;
+  Thread_Control *heir;
+
+  _ISR_Disable( level );
+
+  the_thread->current_state = STATES_READY;
+
+  _Priority_Add_to_bit_map( &the_thread->Priority_map );
+
+  _Chain_Append_unprotected( the_thread->ready, &the_thread->Object.Node );
+
+  _ISR_Flash( level );
+
+  _Thread_Calculate_heir();
+
+  heir = _Thread_Heir;
+
+  if ( !_Thread_Is_executing( heir ) && _Thread_Executing->is_preemptible ) 
+    _Context_Switch_necessary = TRUE;
+
+  _ISR_Enable( level );
+}
Index: cpukit/score/src/threadresettimeslice.c
===================================================================
--- cpukit/score/src/threadresettimeslice.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadresettimeslice.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,72 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Reset_timeslice
+ *
+ *  This routine will remove the running thread from the ready chain
+ *  and place it immediately at the rear of this chain and then the
+ *  timeslice counter is reset.  The heir THREAD will be updated if
+ *  the running is also the currently the heir.
+ *
+ *  Input parameters:   NONE
+ *
+ *  Output parameters:  NONE
+ *
+ *  INTERRUPT LATENCY:
+ *    ready chain
+ *    select heir
+ */
+
+void _Thread_Reset_timeslice( void )
+{
+  ISR_Level       level;
+  Thread_Control *executing;
+  Chain_Control  *ready;
+
+  executing = _Thread_Executing;
+  ready     = executing->ready;
+  _ISR_Disable( level );
+    if ( _Chain_Has_only_one_node( ready ) ) {
+      _ISR_Enable( level );
+      return;
+    }
+    _Chain_Extract_unprotected( &executing->Object.Node );
+    _Chain_Append_unprotected( ready, &executing->Object.Node );
+
+  _ISR_Flash( level );
+
+    if ( _Thread_Is_heir( executing ) )
+      _Thread_Heir = (Thread_Control *) ready->first;
+
+    _Context_Switch_necessary = TRUE;
+
+  _ISR_Enable( level );
+}
Index: cpukit/score/src/threadrestart.c
===================================================================
--- cpukit/score/src/threadrestart.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadrestart.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,79 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*
+ *  _Thread_Restart
+ *
+ *  DESCRIPTION:
+ *
+ *  XXX
+ */
+ 
+boolean _Thread_Restart(
+  Thread_Control      *the_thread,
+  void                *pointer_argument,
+  unsigned32           numeric_argument
+)
+{
+  if ( !_States_Is_dormant( the_thread->current_state ) ) {
+ 
+    _Thread_Set_transient( the_thread );
+    the_thread->resource_count = 0;
+    the_thread->is_preemptible   = the_thread->Start.is_preemptible;
+    the_thread->budget_algorithm = the_thread->Start.budget_algorithm;
+    the_thread->budget_callout   = the_thread->Start.budget_callout;
+
+    the_thread->Start.pointer_argument = pointer_argument;
+    the_thread->Start.numeric_argument = numeric_argument;
+ 
+    if ( !_Thread_queue_Extract_with_proxy( the_thread ) ) {
+ 
+      if ( _Watchdog_Is_active( &the_thread->Timer ) )
+        (void) _Watchdog_Remove( &the_thread->Timer );
+    }
+
+    if ( the_thread->current_priority != the_thread->Start.initial_priority ) {
+      the_thread->real_priority = the_thread->Start.initial_priority;
+      _Thread_Set_priority( the_thread, the_thread->Start.initial_priority );
+    }
+ 
+    _Thread_Load_environment( the_thread );
+ 
+    _Thread_Ready( the_thread );
+ 
+    _User_extensions_Thread_restart( the_thread );
+ 
+    if ( _Thread_Is_executing ( the_thread ) )
+      _Thread_Restart_self();
+ 
+    return TRUE;
+  }
+ 
+  return FALSE;
+}
Index: cpukit/score/src/threadsetpriority.c
===================================================================
--- cpukit/score/src/threadsetpriority.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadsetpriority.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,53 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ * _Thread_Set_priority
+ *
+ * This directive enables and disables several modes of
+ * execution for the requesting thread.
+ *
+ *  Input parameters:
+ *    the_thread   - pointer to thread priority
+ *    new_priority - new priority
+ *
+ *  Output: NONE
+ */
+
+void _Thread_Set_priority(
+  Thread_Control   *the_thread,
+  Priority_Control  new_priority
+)
+{
+  the_thread->current_priority = new_priority;
+  the_thread->ready            = &_Thread_Ready_chain[ new_priority ];
+
+  _Priority_Initialize_information( &the_thread->Priority_map, new_priority );
+}
Index: cpukit/score/src/threadsetstate.c
===================================================================
--- cpukit/score/src/threadsetstate.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadsetstate.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,84 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ * _Thread_Set_state
+ *
+ * This kernel routine sets the requested state in the THREAD.  The
+ * THREAD chain is adjusted if necessary.
+ *
+ * Input parameters:
+ *   the_thread   - pointer to thread control block
+ *   state - state to be set
+ *
+ * Output parameters:  NONE
+ *
+ *  INTERRUPT LATENCY:
+ *    ready chain
+ *    select map
+ */
+
+void _Thread_Set_state(
+  Thread_Control *the_thread,
+  States_Control         state
+)
+{
+  ISR_Level             level;
+  Chain_Control *ready;
+
+  ready = the_thread->ready;
+  _ISR_Disable( level );
+  if ( !_States_Is_ready( the_thread->current_state ) ) {
+    the_thread->current_state =
+       _States_Set( state, the_thread->current_state );
+    _ISR_Enable( level );
+    return;
+  }
+
+  the_thread->current_state = state;
+
+  if ( _Chain_Has_only_one_node( ready ) ) {
+
+    _Chain_Initialize_empty( ready );
+    _Priority_Remove_from_bit_map( &the_thread->Priority_map );
+
+  } else
+    _Chain_Extract_unprotected( &the_thread->Object.Node );
+
+  _ISR_Flash( level );
+
+  if ( _Thread_Is_heir( the_thread ) )
+     _Thread_Calculate_heir();
+
+  if ( _Thread_Is_executing( the_thread ) )
+    _Context_Switch_necessary = TRUE;
+
+  _ISR_Enable( level );
+}
Index: cpukit/score/src/threadsettransient.c
===================================================================
--- cpukit/score/src/threadsettransient.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadsettransient.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,74 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Set_transient
+ *
+ *  This kernel routine places the requested thread in the transient state
+ *  which will remove it from the ready queue, if necessary.  No
+ *  rescheduling is necessary because it is assumed that the transient
+ *  state will be cleared before dispatching is enabled.
+ *
+ *  Input parameters:
+ *    the_thread - pointer to thread control block
+ *
+ *  Output parameters:  NONE
+ *
+ *  INTERRUPT LATENCY:
+ *    only case
+ */
+
+void _Thread_Set_transient(
+  Thread_Control *the_thread
+)
+{
+  ISR_Level             level;
+  unsigned32            old_state;
+  Chain_Control *ready;
+
+  ready = the_thread->ready;
+  _ISR_Disable( level );
+
+  old_state = the_thread->current_state;
+  the_thread->current_state = _States_Set( STATES_TRANSIENT, old_state );
+
+  if ( _States_Is_ready( old_state ) ) {
+    if ( _Chain_Has_only_one_node( ready ) ) {
+
+      _Chain_Initialize_empty( ready );
+      _Priority_Remove_from_bit_map( &the_thread->Priority_map );
+
+    } else
+      _Chain_Extract_unprotected( &the_thread->Object.Node );
+  }
+
+  _ISR_Enable( level );
+
+}
Index: cpukit/score/src/threadstackallocate.c
===================================================================
--- cpukit/score/src/threadstackallocate.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadstackallocate.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,82 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Stack_Allocate
+ *
+ *  Allocate the requested stack space for the thread.
+ *  return the actual size allocated after any adjustment
+ *  or return zero if the allocation failed.
+ *  Set the Start.stack field to the address of the stack
+ */
+
+unsigned32 _Thread_Stack_Allocate(
+  Thread_Control *the_thread,
+  unsigned32 stack_size
+)
+{
+  void *stack_addr = 0;
+ 
+  if ( !_Stack_Is_enough( stack_size ) )
+    stack_size = STACK_MINIMUM_SIZE;
+ 
+  /*
+   * Call ONLY the CPU table stack allocate hook, _or_ the
+   * the RTEMS workspace allocate.  This is so the stack free
+   * routine can call the correct deallocation routine.
+   */
+
+  if ( _CPU_Table.stack_allocate_hook )
+  {
+    stack_addr = (*_CPU_Table.stack_allocate_hook)( stack_size );
+  } else {
+
+    /*
+     *  First pad the requested size so we allocate enough memory
+     *  so the context initialization can align it properly.  The address
+     *  returned the workspace allocate must be directly stored in the
+     *  stack control block because it is later used in the free sequence.
+     *
+     *  Thus it is the responsibility of the CPU dependent code to 
+     *  get and keep the stack adjust factor, the stack alignment, and 
+     *  the context initialization sequence in sync.
+     */
+
+    stack_size = _Stack_Adjust_size( stack_size );
+    stack_addr = _Workspace_Allocate( stack_size );
+  }
+ 
+  if ( !stack_addr )
+      stack_size = 0;
+ 
+  the_thread->Start.stack = stack_addr;
+ 
+  return stack_size;
+}
Index: cpukit/score/src/threadstackfree.c
===================================================================
--- cpukit/score/src/threadstackfree.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadstackfree.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,57 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*
+ *  _Thread_Stack_Free
+ *
+ *  Deallocate the Thread's stack.
+ */
+
+void _Thread_Stack_Free(
+  Thread_Control *the_thread
+)
+{
+    /*
+     *  If the API provided the stack space, then don't free it.
+     */
+
+    if ( !the_thread->Start.core_allocated_stack )
+      return;
+
+    /*
+     * Call ONLY the CPU table stack free hook, or the
+     * the RTEMS workspace free.  This is so the free
+     * routine properly matches the allocation of the stack.
+     */
+
+    if ( _CPU_Table.stack_free_hook )
+        (*_CPU_Table.stack_free_hook)( the_thread->Start.Initial_stack.area );
+    else
+        _Workspace_Free( the_thread->Start.Initial_stack.area );
+}
Index: cpukit/score/src/threadstart.c
===================================================================
--- cpukit/score/src/threadstart.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadstart.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,65 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*
+ *  _Thread_Start
+ *
+ *  DESCRIPTION:
+ *
+ *  XXX
+ */
+ 
+boolean _Thread_Start(
+  Thread_Control       *the_thread,
+  Thread_Start_types    the_prototype,
+  void                 *entry_point,
+  void                 *pointer_argument,
+  unsigned32            numeric_argument
+)
+{
+  if ( _States_Is_dormant( the_thread->current_state ) ) {
+ 
+    the_thread->Start.entry_point      = (Thread_Entry) entry_point;
+   
+    the_thread->Start.prototype        = the_prototype;
+    the_thread->Start.pointer_argument = pointer_argument;
+    the_thread->Start.numeric_argument = numeric_argument;
+ 
+    _Thread_Load_environment( the_thread );
+ 
+    _Thread_Ready( the_thread );
+ 
+    _User_extensions_Thread_start( the_thread );
+ 
+    return TRUE;
+  }
+ 
+  return FALSE;
+ 
+}
Index: cpukit/score/src/threadstartmultitasking.c
===================================================================
--- cpukit/score/src/threadstartmultitasking.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadstartmultitasking.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,90 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Start_multitasking
+ *
+ *  This kernel routine readies the requested thread, the thread chain
+ *  is adjusted.  A new heir thread may be selected.
+ *
+ *  Input parameters:
+ *    system_thread - pointer to system initialization thread control block
+ *    idle_thread   - pointer to idle thread control block
+ *
+ *  Output parameters:  NONE
+ *
+ *  NOTE:  This routine uses the "blocking" heir selection mechanism.
+ *         This insures the correct heir after a thread restart.
+ *
+ *  INTERRUPT LATENCY:
+ *    ready chain
+ *    select heir
+ */
+
+void _Thread_Start_multitasking( void )
+{
+  /*
+   *  The system is now multitasking and completely initialized.  
+   *  This system thread now either "goes away" in a single processor 
+   *  system or "turns into" the server thread in an MP system.
+   */
+
+  _System_state_Set( SYSTEM_STATE_UP );
+
+  _Context_Switch_necessary = FALSE;
+
+  _Thread_Executing = _Thread_Heir;
+
+   /*
+    * Get the init task(s) running.
+    *
+    * Note: Thread_Dispatch() is normally used to dispatch threads.  As
+    *       part of its work, Thread_Dispatch() restores floating point
+    *       state for the heir task.
+    *
+    *       This code avoids Thread_Dispatch(), and so we have to restore
+    *       (actually initialize) the floating point state "by hand".
+    *
+    *       Ignore the CPU_USE_DEFERRED_FP_SWITCH because we must always
+    *       switch in the first thread if it is FP.
+    */
+ 
+
+#if ( CPU_HARDWARE_FP == TRUE ) || ( CPU_SOFTWARE_FP == TRUE )
+   /*
+    *  don't need to worry about saving BSP's floating point state
+    */
+
+   if ( _Thread_Heir->fp_context != NULL )
+     _Context_Restore_fp( &_Thread_Heir->fp_context );
+#endif
+
+  _Context_Switch( &_Thread_BSP_context, &_Thread_Heir->Registers );
+}
Index: cpukit/score/src/threadtickletimeslice.c
===================================================================
--- cpukit/score/src/threadtickletimeslice.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadtickletimeslice.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,87 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Tickle_timeslice
+ *
+ *  This scheduler routine determines if timeslicing is enabled
+ *  for the currently executing thread and, if so, updates the
+ *  timeslice count and checks for timeslice expiration.
+ *
+ *  Input parameters:   NONE
+ *
+ *  Output parameters:  NONE
+ */
+
+void _Thread_Tickle_timeslice( void )
+{
+  Thread_Control *executing;
+
+  executing = _Thread_Executing;
+
+  /*
+   *  Increment the number of ticks this thread has been executing
+   */
+
+  executing->ticks_executed++;
+
+  /*
+   *  If the thread is not preemptible or is not ready, then 
+   *  just return.
+   */
+
+  if ( !executing->is_preemptible )
+    return;
+
+  if ( !_States_Is_ready( executing->current_state ) )
+    return;
+
+  /*
+   *  The cpu budget algorithm determines what happens next.
+   */
+
+  switch ( executing->budget_algorithm ) {
+    case THREAD_CPU_BUDGET_ALGORITHM_NONE:
+      break;
+
+    case THREAD_CPU_BUDGET_ALGORITHM_RESET_TIMESLICE:
+    case THREAD_CPU_BUDGET_ALGORITHM_EXHAUST_TIMESLICE:
+      if ( --executing->cpu_time_budget == 0 ) {
+        _Thread_Reset_timeslice();
+        executing->cpu_time_budget = _Thread_Ticks_per_timeslice;
+      }
+      break;
+
+    case THREAD_CPU_BUDGET_ALGORITHM_CALLOUT:
+      if ( --executing->cpu_time_budget == 0 )
+        (*executing->budget_callout)( executing );
+      break;
+  }
+}
Index: cpukit/score/src/threadyieldprocessor.c
===================================================================
--- cpukit/score/src/threadyieldprocessor.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ cpukit/score/src/threadyieldprocessor.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,73 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Yield_processor
+ *
+ *  This kernel routine will remove the running THREAD from the ready chain
+ *  and place it immediatly at the rear of this chain.  Reset timeslice
+ *  and yield the processor functions both use this routine, therefore if
+ *  reset is TRUE and this is the only thread on the chain then the
+ *  timeslice counter is reset.  The heir THREAD will be updated if the
+ *  running is also the currently the heir.
+ *
+ *  Input parameters:   NONE
+ *
+ *  Output parameters:  NONE
+ *
+ *  INTERRUPT LATENCY:
+ *    ready chain
+ *    select heir
+ */
+
+void _Thread_Yield_processor( void )
+{
+  ISR_Level       level;
+  Thread_Control *executing;
+  Chain_Control  *ready;
+
+  executing = _Thread_Executing;
+  ready     = executing->ready;
+  _ISR_Disable( level );
+    if ( !_Chain_Has_only_one_node( ready ) ) {
+      _Chain_Extract_unprotected( &executing->Object.Node );
+      _Chain_Append_unprotected( ready, &executing->Object.Node );
+
+      _ISR_Flash( level );
+
+      if ( _Thread_Is_heir( executing ) )
+        _Thread_Heir = (Thread_Control *) ready->first;
+      _Context_Switch_necessary = TRUE;
+    }
+    else if ( !_Thread_Is_heir( executing ) )
+      _Context_Switch_necessary = TRUE;
+
+  _ISR_Enable( level );
+}
